<?php
/**
 * Created by PhpStorm.
 * User: francismararaujo
 * Date: 23/10/14
 * Time: 17:07
 */

namespace TecDiet\Controllers;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Response\Error;

use TecDiet\Services\EnteralFeedingsService;

class EnteralFeedingsController extends \Zeedhi\Framework\Controller\Simple {

    protected $enteralFeedingsService;

    public function __construct(EnteralFeedingsService $enteralFeedingsService) {
        $this->enteralFeedingsService = $enteralFeedingsService;
    }

    public function save(Request\DataSet $request, Response $response) {
        $enteralFeedings = $request->getDataSet()->getRows();
        if($enteralFeedings) {
            try {
                $dataSet = $this->enteralFeedingsService->save($enteralFeedings);
                if(sizeof($dataSet) != 0){
                    $response->addDataSet(new DataSet('error', $dataSet));
                }
            } catch(\Exception $e) {
                $response->setError(new Error($e->getMessage(), $e->getCode()));
            }
        }
    }
    
    public function delete(Request\DataSet $request, Response $response){
        $enteralFeedings = $request->getDataSet()->getRows();
        if($enteralFeedings){
            try{
                $dataSet = $this->enteralFeedingsService->delete($enteralFeedings);
                if(sizeof($dataSet) != 0){
                    $response->addDataSet(new DataSet('error'), $dataSet);
                }
            }catch(\Exception $e){
                $response->setError(new Error($e->getMessage(), $e->getCode()));
            }
        }
    }

}