<?php
/**
 * Created by PhpStorm.
 * User: francismararaujo
 * Date: 23/10/14
 * Time: 17:07
 */

namespace TecDiet\Controllers;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Response\Error;

use TecDiet\Services\LactaryFeedingsService;

class LactaryFeedingsController extends \Zeedhi\Framework\Controller\Simple {

    protected $lactaryFeedingsService;

    public function __construct(LactaryFeedingsService $lactaryFeedingsService) {
        $this->lactaryFeedingsService = $lactaryFeedingsService;
    }

    public function save(Request\DataSet $request, Response $response) {
        $lactaryFeedings = $request->getDataSet()->getRows();
        if($lactaryFeedings) {
            try {
                $dataSet = $this->lactaryFeedingsService->save($lactaryFeedings);
                if(sizeof($dataSet) != 0){
                    $response->addDataSet(new DataSet('error',$dataSet));
                }
            } catch(\Exception $e) {
                $response->setError(new Error($e->getMessage(), $e->getCode()));
            }
        }
    }
    
    public function delete(Request\DataSet $request, Response $response) {
        $lactaryFeedings = $request->getDataSet()->getRows();
        if($lactaryFeedings){
            try{
                $dataSet = $this->lactaryFeedingsService->delete($lactaryFeedings);
                if(sizeof($dataSet) != 0){
                    $response->addDataSet(new DataSet('error', $dataSet));
                }
            } catch (\Exception $e){
                $response->setError(new Error($e->getMessage(), $e->getCode()));
            }
        }
    }

}