<?php

namespace TecDiet\Services;

use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Response\Error;

class VerificaRestricaoAlimentar {
    
    const QUERY_PRODUTOS = "SELECT INTOL.CDPRODUTO
                              FROM ( SELECT CDPRODUTO
                                       FROM RECESERV
                                      WHERE (CDFILAUXPRAT = :P_CDFILAUXPRAT OR CDFILAUXPRAT = 'P') 
                                        AND (CDPRATO      LIKE :P_CDPRATO ||'%')                        
                                        AND (CDFILIAL     = :P_CDFILIAL)                           
                                        AND (CDSERVFILI   = :P_CDSERVFILI)
                            
                                      UNION ALL
                            
                                     SELECT CDPRODUTO
                                       FROM RECEFILI
                                      WHERE (CDFILAUXPRAT = :P_CDFILAUXPRAT OR CDFILAUXPRAT = 'P')
                                        AND (CDPRATO      LIKE :P_CDPRATO ||'%')                       
                                        AND (CDFILIAL     = :P_CDFILIAL)                          
                                        AND NOT EXISTS ( SELECT CDPRATO
                                                           FROM RECESERV
                                                          WHERE (CDFILAUXPRAT = :P_CDFILAUXPRAT OR CDFILAUXPRAT = 'P')
                                                            AND (CDPRATO      LIKE :P_CDPRATO ||'%')                      
                                                            AND (CDFILIAL     = :P_CDFILIAL)                          
                                                            AND (CDSERVFILI   = :P_CDSERVFILI) )
                            
                                      UNION ALL
                                       
                                     SELECT CDPRODUTO
                                       FROM RECEPADR
                                      WHERE (CDFILAUXPRAT = :P_CDFILAUXPRAT OR CDFILAUXPRAT = 'P')
                                        AND (CDPRATO      LIKE :P_CDPRATO ||'%')                     
                                        AND NOT EXISTS ( SELECT CDPRATO
                                                           FROM RECEFILI
                                                          WHERE (CDFILAUXPRAT = :P_CDFILAUXPRAT OR CDFILAUXPRAT = 'P')
                                                            AND (CDPRATO LIKE :P_CDPRATO ||'%')                       
                                                            AND (CDFILIAL     = :P_CDFILIAL) ) 
                                        AND NOT EXISTS ( SELECT CDPRATO
                                                           FROM RECESERV
                                                          WHERE (CDFILAUXPRAT = :P_CDFILAUXPRAT OR CDFILAUXPRAT = 'P')
                                                            AND (CDPRATO  LIKE :P_CDPRATO ||'%')                     
                                                            AND (CDFILIAL     = :P_CDFILIAL)                          
                                                            AND (CDSERVFILI   = :P_CDSERVFILI) )) PRODUTO,
                                   ( SELECT PRO.CDPRODUTO
                                       FROM INTOALIM INT, PRSUBGRPROD PRO
                                      WHERE (INT.CDFILIAL    = :P_CDFILIAL)                          
                                        AND (INT.CDPACIENTE  = :P_CDPACIENTE)                        
                                        AND (PRO.CDFILISUBGR = :P_CDFILIAL OR PRO.CDFILISUBGR = 'P') 
                                        AND (INT.CDGRUPPROD  = PRO.CDGRUPPROD)                       
                                        AND (INT.CDSUBGRPROD = PRO.CDSUBGRPROD) ) INTOL
                             WHERE (PRODUTO.CDPRODUTO = INTOL.CDPRODUTO)
                            
                             UNION ALL
                            
                            SELECT PRSUBGRPROD.CDPRODUTO
                              FROM DIAGINTER, 
                                   PRSUBGRPROD, 
                                   RESTDIAG,
                                   ( SELECT CDPRODUTO
                                       FROM RECESERV
                                      WHERE (CDFILAUXPRAT = :P_CDFILAUXPRAT OR CDFILAUXPRAT = 'P') 
                                        AND (CDPRATO LIKE :P_CDPRATO ||'%')                        
                                        AND (CDFILIAL     = :P_CDFILIAL)                           
                                        AND (CDSERVFILI   = :P_CDSERVFILI)
                            
                                      UNION ALL
                            
                                     SELECT CDPRODUTO
                                       FROM RECEFILI
                                      WHERE (CDFILAUXPRAT = :P_CDFILAUXPRAT OR CDFILAUXPRAT = 'P')
                                        AND (CDPRATO LIKE :P_CDPRATO ||'%')                       
                                        AND (CDFILIAL     = :P_CDFILIAL)                          
                                        AND NOT EXISTS ( SELECT CDPRATO
                                                           FROM RECESERV
                                                          WHERE (CDFILAUXPRAT = :P_CDFILAUXPRAT OR CDFILAUXPRAT = 'P')
                                                            AND (CDPRATO  LIKE :P_CDPRATO ||'%')                      
                                                            AND (CDFILIAL     = :P_CDFILIAL)                          
                                                            AND (CDSERVFILI   = :P_CDSERVFILI) )
                            
                                      UNION ALL
                            
                                     SELECT CDPRODUTO
                                       FROM RECEPADR
                                      WHERE (CDFILAUXPRAT = :P_CDFILAUXPRAT OR CDFILAUXPRAT = 'P')
                                        AND (CDPRATO  LIKE :P_CDPRATO ||'%')                      
                                        AND NOT EXISTS ( SELECT CDPRATO
                                                           FROM RECEFILI
                                                          WHERE (CDFILAUXPRAT = :P_CDFILAUXPRAT OR CDFILAUXPRAT = 'P')
                                                            AND (CDPRATO LIKE :P_CDPRATO ||'%')                       
                                                            AND (CDFILIAL     = :P_CDFILIAL) )
                                        AND NOT EXISTS ( SELECT CDPRATO
                                                           FROM RECESERV
                                                          WHERE (CDFILAUXPRAT = :P_CDFILAUXPRAT OR CDFILAUXPRAT = 'P')
                                                            AND (CDPRATO  LIKE :P_CDPRATO ||'%')                      
                                                            AND (CDFILIAL     = :P_CDFILIAL)                          
                                                            AND (CDSERVFILI   = :P_CDSERVFILI) )
                                   ) PRODUTO, 
                                   PARAMGERAL
                             WHERE (DIAGINTER.CDFILIAL      = :P_CDFILIAL)                                  
                               AND (DIAGINTER.CDPACIENTE    = :P_CDPACIENTE)
                               AND (DIAGINTER.DTINTERNA     = :P_DTINTERNA)
                               AND (DIAGINTER.CDTABECDI     = PARAMGERAL.CDTABECDIPA)
                               AND (PRSUBGRPROD.CDFILISUBGR = :P_CDFILIAL OR PRSUBGRPROD.CDFILISUBGR = 'P')
                               AND (DIAGINTER.CDTABECDI     = RESTDIAG.CDTABECDI)
                               AND (DIAGINTER.CDDIAGNOST    = RESTDIAG.CDDIAGNOST)
                               AND (RESTDIAG.CDGRUPPROD     = PRSUBGRPROD.CDGRUPPROD)
                               AND (RESTDIAG.CDSUBGRPROD    = PRSUBGRPROD.CDSUBGRPROD)
                               AND (PRODUTO.CDPRODUTO       = PRSUBGRPROD.CDPRODUTO)
                            
                             UNION ALL
                            
                            SELECT PRSUBGRPROD.CDPRODUTO
                              FROM DIAGPACI, 
                                   PRSUBGRPROD, 
                                   RESTDIAG,
                                   ( SELECT CDPRODUTO
                                       FROM RECESERV
                                      WHERE (CDFILAUXPRAT = :P_CDFILAUXPRAT OR CDFILAUXPRAT = 'P')
                                        AND (CDPRATO      LIKE :P_CDPRATO ||'%')                       
                                        AND (CDFILIAL     = :P_CDFILIAL)                          
                                        AND (CDSERVFILI   = :P_CDSERVFILI)
                            
                                      UNION ALL
                            
                                     SELECT CDPRODUTO
                                       FROM RECEFILI
                                      WHERE (CDFILAUXPRAT = :P_CDFILAUXPRAT OR CDFILAUXPRAT = 'P')
                                        AND (CDPRATO      LIKE :P_CDPRATO ||'%')                       
                                        AND (CDFILIAL     = :P_CDFILIAL)                          
                                        AND NOT EXISTS  ( SELECT CDPRATO
                                                            FROM RECESERV
                                                           WHERE (CDFILAUXPRAT = :P_CDFILAUXPRAT OR CDFILAUXPRAT = 'P')
                                                             AND (CDPRATO  LIKE :P_CDPRATO ||'%')                      
                                                             AND (CDFILIAL     = :P_CDFILIAL)                          
                                                             AND (CDSERVFILI   = :P_CDSERVFILI) )
                            
                                      UNION ALL
                            
                                     SELECT CDPRODUTO
                                       FROM RECEPADR
                                      WHERE (CDFILAUXPRAT = :P_CDFILAUXPRAT OR CDFILAUXPRAT = 'P')
                                        AND (CDPRATO  LIKE :P_CDPRATO ||'%')                      
                                        AND NOT EXISTS ( SELECT CDPRATO
                                                           FROM RECEFILI
                                                          WHERE (CDFILAUXPRAT = :P_CDFILAUXPRAT OR CDFILAUXPRAT = 'P')
                                                            AND (CDPRATO LIKE :P_CDPRATO ||'%')                       
                                                            AND (CDFILIAL     = :P_CDFILIAL) )
                                        AND NOT EXISTS ( SELECT CDPRATO
                                                           FROM RECESERV
                                                          WHERE (CDFILAUXPRAT = :P_CDFILAUXPRAT OR CDFILAUXPRAT = 'P')
                                                            AND (CDPRATO  LIKE :P_CDPRATO ||'%')                      
                                                            AND (CDFILIAL     = :P_CDFILIAL)                          
                                                            AND (CDSERVFILI   = :P_CDSERVFILI) )) PRODUTO, 
                                   PARAMGERAL
                             WHERE (DIAGPACI.CDFILIAL       = :P_CDFILIAL)                                  
                               AND (DIAGPACI.CDPACIENTE     = :P_CDPACIENTE)                                
                               AND (DIAGPACI.DTCONSPACI    >= :P_DTINTERNA)                                 
                               AND (DIAGPACI.CDTABECDI      = PARAMGERAL.CDTABECDIPA)                       
                               AND (PRSUBGRPROD.CDFILISUBGR = :P_CDFILIAL OR PRSUBGRPROD.CDFILISUBGR = 'P') 
                               AND (DIAGPACI.CDTABECDI      = RESTDIAG.CDTABECDI)                           
                               AND (DIAGPACI.CDDIAGNOST     = RESTDIAG.CDDIAGNOST)                          
                               AND (RESTDIAG.CDGRUPPROD     = PRSUBGRPROD.CDGRUPPROD)                       
                               AND (RESTDIAG.CDSUBGRPROD    = PRSUBGRPROD.CDSUBGRPROD)                     
                               AND (PRODUTO.CDPRODUTO       = PRSUBGRPROD.CDPRODUTO)
                            
                             UNION ALL
                            
                            SELECT PRATO.CDPRODUTO
                              FROM MEDICAPACI MEDPACI,
                                   PRINATIVMEDI PRIMED,
                                   PRINATIVNUTR PRINUT, NUTRIENTE,
                                   NUTRPROD, 
                                   ( SELECT CDPRODUTO
                                       FROM RECESERV
                                      WHERE (CDFILAUXPRAT = :P_CDFILAUXPRAT OR CDFILAUXPRAT = 'P') 
                                        AND (CDPRATO      = :P_CDPRATO)                            
                                        AND (CDFILIAL     = :P_CDFILIAL)                           
                                        AND (CDSERVFILI   = :P_CDSERVFILI)
                            
                                      UNION ALL
                            
                                     SELECT CDPRODUTO
                                       FROM RECEFILI
                                      WHERE (CDFILAUXPRAT = :P_CDFILAUXPRAT OR CDFILAUXPRAT = 'P') 
                                        AND (CDPRATO      = :P_CDPRATO)                            
                                        AND (CDFILIAL     = :P_CDFILIAL)                           
                                        AND NOT EXISTS ( SELECT CDPRATO
                                                           FROM RECESERV
                                                          WHERE (CDFILAUXPRAT = :P_CDFILAUXPRAT OR CDFILAUXPRAT = 'P')
                                                            AND (CDPRATO      = :P_CDPRATO)                           
                                                            AND (CDFILIAL     = :P_CDFILIAL)                          
                                                            AND (CDSERVFILI   = :P_CDSERVFILI) )
                                      UNION ALL
                                     SELECT CDPRODUTO
                                       FROM RECEPADR
                                      WHERE (CDFILAUXPRAT = :P_CDFILAUXPRAT OR CDFILAUXPRAT = 'P') 
                                        AND (CDPRATO      = :P_CDPRATO)                            
                                        AND NOT EXISTS ( SELECT CDPRATO
                                                           FROM RECEFILI
                                                          WHERE (CDFILAUXPRAT = :P_CDFILAUXPRAT OR CDFILAUXPRAT = 'P')
                                                            AND (CDPRATO      = :P_CDPRATO)                           
                                                            AND (CDFILIAL     = :P_CDFILIAL) ) 
                                        AND NOT EXISTS ( SELECT CDPRATO
                                                           FROM RECESERV
                                                          WHERE (CDFILAUXPRAT = :P_CDFILAUXPRAT OR CDFILAUXPRAT = 'P')
                                                            AND (CDPRATO      = :P_CDPRATO)                          
                                                            AND (CDFILIAL     = :P_CDFILIAL)                          
                                                            AND (CDSERVFILI   = :P_CDSERVFILI) )) PRATO
                             WHERE (MEDPACI.CDFILIAL     = :P_CDFILIAL)                                  
                               AND (MEDPACI.CDPACIENTE   = :P_CDPACIENTE)                                
                               AND (MEDPACI.CDMEDICAMENT = PRIMED.CDMEDICAMENT)                          
                               AND (:P_DTCARDAPIO BETWEEN MEDPACI.DTINIUSOMEDI AND MEDPACI.DTFINUSOMEDI) 
                               AND (PRIMED.CDPRINATIV     = PRINUT.CDPRINATIV)                           
                               AND (NUTRIENTE.CDNUTRIENTE = PRINUT.CDNUTRIENTE)                          
                               AND (PRINUT.IDABPRATNUTR   = '1')                                         
                               AND (NUTRPROD.CDNUTRIENTE  = PRINUT.CDNUTRIENTE)                          
                               AND (NUTRPROD.CDPRODUTO    = PRATO.CDPRODUTO)";
                               
    const QUERY_FEEDINGS = "SELECT CFC.CDFILIAL,
                                   SER.CDSERVFILI,
                                   CFC.CDPRATO,
                                   CFC.CDFILAUXPRAT,
                                   CFC.CDPACIENTE,
                                   CFC.CDSEQUCOPR,
                                   CFC.IDESCOCONF,
                                   TO_CHAR(SER.DTINTERNA, 'DD/MM/YYYY') AS DTINTERNA,
                                   TO_CHAR(SER.DTSERVINTE, 'DD/MM/YYYY') AS DTCARDAPIO
                              FROM CONFESCO CFC
                             INNER JOIN SERVINTE SER
                                ON SER.CDFILIAL          = CFC.CDFILIAL
                               AND SER.CDPACIENTE        = CFC.CDPACIENTE
                               AND SER.DTSERVINTE        = CFC.DTSERVINTE
                               AND SER.NRSEQUSERV        = CFC.NRSEQUSERV
                               AND SER.NRORG             = CFC.NRORG
                             WHERE CFC.CDFILIAL          = :P_CDFILIAL 
                               AND SER.CDSERVFILI        = :P_CDSERVFILI
                               AND CFC.CDPACIENTE        = :P_CDPACIENTE
                               AND CFC.DTSERVINTE        = :P_DTSERVINTE
                               AND CFC.NRSEQUSERV        = :P_NRSEQUSERV
                               AND TRUNC(SER.DTINTERNA)  = :P_DTINTERNA";
                              

    const UPDATE_CONFESCO = "UPDATE CONFESCO
                                SET IDRESTCONF = :P_IDRESTCONF
                              WHERE CDFILIAL   = :P_CDFILIAL 
                                AND CDPACIENTE = :P_CDPACIENTE 
                                AND DTSERVINTE = :P_DTSERVINTE 
                                AND NRSEQUSERV = :P_NRSEQUSERV 
                                AND CDSEQUCOPR = :P_CDSEQUCOPR";
                                
    const UPDATE_SERVINTE = "UPDATE SERVINTE
                                SET IDRESTSERIN = :P_IDRESTSERIN
                              WHERE CDFILIAL    = :P_CDFILIAL 
                                AND CDPACIENTE  = :P_CDPACIENTE 
                                AND DTSERVINTE  = :P_DTSERVINTE 
                                AND NRSEQUSERV  = :P_NRSEQUSERV";
    
    const NO_RESTRICTION_INTOLERANCE = '0';
    const HAD_RESTRICTION_INTOLERANCE = '1';
    
    protected $entityManager;
    protected $connection;
    
    public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
        $this->connection = $entityManager->getConnection();
    }
    
    /**
     * Verifica restrições alimentares atualizando a prescrição e seus pratos. 
     * 
     * @access public
     * @param  Array  $row
     * @param  Object $response
     * @return void 
     */
     
    public function executeVerificaRestricaoAlimentar($row, $response){
        $updateIdrestserin = $this->updateIdrestserin($row);
        $this->connection->beginTransaction();
        try{
            $this->updateServinte($row, $updateIdrestserin);
            $this->connection->commit();
        } catch(\Exception $e){
            $response->setError(new Error($e->getMessage(), 500));
            $this->connection->rollback();
        }
    }
    
    /**
     * Retorna as prescrições
     * 
     * @access private
     * @param  Array $row
     */
    
    private function findFeedings($row){
        $stmt = $this->connection->prepare(self::QUERY_FEEDINGS);
        $stmt->execute(array(
            ':P_CDFILIAL' => $row['P_CDFILIAL'],
            ':P_CDSERVFILI' => $row['P_CDSERVFILI'],
            ':P_CDPACIENTE' => $row['P_CDPACIENTE'],
            ':P_DTSERVINTE' => $row['P_DTSERVINTE'],
            ':P_NRSEQUSERV' => $row['P_NRSEQUSERV'],
            ':P_DTINTERNA' => $row['P_DTINTERNA'],
            ));
        return $stmt->fetchAll(\PDO::FETCH_ASSOC);
    }

    /**
     * Atualiza os pratos com restrição e retorna o id que definirá se a 
     * prescrição possui restrição ou não.
     * 
     * @access private
     * @param  Array $row
     */

   	private function updateIdrestserin($row) {
        $stmt = $this->connection->prepare(self::QUERY_PRODUTOS);
        $params = $this->findFeedings($row);
        $updateId = self::NO_RESTRICTION_INTOLERANCE;
        $this->connection->beginTransaction();
        try{
            foreach($params as $param){
                $updateIdConfesco = self::NO_RESTRICTION_INTOLERANCE;
                $stmt->execute(array(
                    'P_CDFILIAL'     => $param['CDFILIAL'],
                    'P_CDSERVFILI'   => $param['CDSERVFILI'],
                    'P_CDPACIENTE'   => $param['CDPACIENTE'],
                    'P_CDFILAUXPRAT' => $param['CDFILAUXPRAT'],
                    'P_CDPRATO'      => $param['CDPRATO'],
                    'P_DTINTERNA'    => $param['DTINTERNA'],
                    'P_DTCARDAPIO'   => $param['DTCARDAPIO']
                ));
                $produtos = $stmt->fetchAll(\PDO::FETCH_ASSOC);
                if(!empty($produtos) && $param['IDESCOCONF'] === 'S'){
                    $updateId = self::HAD_RESTRICTION_INTOLERANCE;
                    $updateIdConfesco = self::HAD_RESTRICTION_INTOLERANCE;
                }
                $this->updateConfesco($row, $param['CDSEQUCOPR'], $updateIdConfesco);
            }
            $this->connection->commit();
        } catch (\Exception $e){
            $response->setError(new Error($e->getMessage(), 500));
            $this->connection->rollback();
        }
        return $updateId;
        
    }
    
    /**
     * Atualiza um prato da prescrição.
     * 
     * @access private
     * @param  Array $row
     * @param  String $cdsequcopr
     * @param  String $updateId
     */
    
    private function updateConfesco($row, $cdsequcopr, $updateId) {
        $stmt = $this->connection->prepare(self::UPDATE_CONFESCO);
        $stmt->execute(
            array(
                'P_IDRESTCONF' => $updateId,
                'P_CDFILIAL'   => $row['P_CDFILIAL'],
                'P_CDPACIENTE' => $row['P_CDPACIENTE'],
                'P_DTSERVINTE' => $row['P_DTSERVINTE'],
                'P_NRSEQUSERV' => $row['P_NRSEQUSERV'],
                'P_CDSEQUCOPR' => $cdsequcopr
            )
        );
    }
    
    /**
     * Atualiza a prescrição.
     * 
     * @access private
     * @param  Array $row
     * @param  String $updateId
     */
    
    private function updateServinte($row, $updateId) {
        $stmt = $this->connection->prepare(self::UPDATE_SERVINTE);
        $stmt->execute(
            array(
                'P_IDRESTSERIN' => $updateId,
                'P_CDFILIAL'    => $row['P_CDFILIAL'],
                'P_CDPACIENTE'  => $row['P_CDPACIENTE'],
                'P_DTSERVINTE'  => $row['P_DTSERVINTE'],
                'P_NRSEQUSERV'  => $row['P_NRSEQUSERV']
            )
        );
    }

}