function ruiFABController($rootScope, ApplicationContext,eventAggregator, templateManager) {


    function getNewFAB() {
        var FABRoot = document.createElement('span');
        var FABIcon = document.createElement('span');
        var FABAction = {};

        FABIcon.className = "material-icons fab-icon";
        FABIcon.textContent = "pregnant_woman";

        FABRoot.classList.add('fab-root');
        FABRoot.appendChild(FABIcon);

        FABRoot.setIcon = function( /*string*/ iconName) {
            if (typeof iconName !== 'string') {
                console.log('%cfunction setIcon expects parameter 1 ' +
                    'to be of type string. Received ' + typeof iconName + ' instead',
                    'font-size:20px;background-color:red;color:yellow;');
                return "YOUR CALL WAS REJECTED LOSER";
            }
            FABIcon.textContent = iconName;
        };

        FABRoot.setAction = function( /*object*/ action) {
            if (typeof action !== 'object') {
                console.log('%cfunction setIcon expects parameter 1 ' +
                    'to be of type Object. Received ' + typeof action + ' instead',
                    'font-size:20px;background-color:red;color:yellow;');
                return "YOUR CALL WAS REJECTED LOSER";
            }
            FABAction = action;
        };


        FABRoot.id = "rui-FAB";
        FABRoot.addEventListener('click', function() {
            var eventContext = getApplicationContextWithEventArgs(FABAction);
            $rootScope.$eval(FABRoot.code, eventContext);
            $rootScope.$apply();
        });

        return FABRoot;
    }

    var FABElement = getNewFAB();
    var defaultIconName = "sentimentverysatisfied";

    var getApplicationContextWithEventArgs = function(eventOwner) {
        ApplicationContext.args = {
            owner: eventOwner
        };
        return ApplicationContext;
    };


    var modes = [
        "FAB_edit",
        "FAB_view",
        "FAB_list",
        "FAB_checked_rows",
        "FAB"
    ];

    // find the first action with the FAB mode
    var findActionToDisplay = function(widget) {
        var currentWidgetMode = widget.mode;
        var actions = widget.actions;
        if (widget.hasCheckedRows()) {
            for (var j = actions.length; j--;) {
                if (actions[j].showAsAction === 'FAB_checked_rows') {
                    return actions[j];
                }
            }
        } else {
            for (var i = actions.length; i--;) {
                if (actions[i].showAsAction === 'FAB'||
                    actions[i].showAsAction.indexOf('FAB_'+currentWidgetMode) !== -1) {
                    return actions[i];
                }
            }
        }
    };

    //add a watch to check if the active widget has changed.
    //TODO: find a better solution that DOESN'T use ANGULARJS

    var changeFABVisibility = function() {
        if(!templateManager.container){
            return;
        }
        var widget = templateManager.container.getActiveWidget();
        var action = findActionToDisplay(widget);
        // /*if the*/ TODO: add comment here
        FABElement.className = 'fab-root';
        if (action) {
            FABElement.code = action.code;
            FABElement.setIcon(action.ruiIcon || defaultIconName);
            FABElement.setAction(action);
            FABElement.zhWidgetMode = action.showAsAction;
            FABElement.className += ' active';
            if(action.class){
                FABElement.className += " " + action.class;
            }
        }
    };

    $rootScope.$watch(function() {
        return templateManager.container && templateManager.container.getActiveWidget().hasCheckedRows();
        // else , will return undefined
    }, function(hasCheckedRows) {
        changeFABVisibility();
    });

    $rootScope.$watch(function() {
        return templateManager.container && templateManager.container.getActiveWidget();
        // else , will return undefined
    }, function(hasChanged) {
        changeFABVisibility();
    });

    $rootScope.$watch(function() {
        return templateManager.container && templateManager.container.getActiveWidget().mode;
        // else , will return undefined
    }, function(hasChanged) {
        changeFABVisibility();
    });

    var attachFABToZhContainer = function() {
        var containerToInjectFAB = document.querySelector('div.container');
        if(containerToInjectFAB){
            containerToInjectFAB.appendChild(FABElement);
            return true;
        } else {
            return false;
        }
    };

    // attach the button to the container, using the attempt and error strategy
    var setIntervalReference = setInterval(function(){
        if(attachFABToZhContainer()){
            clearInterval(setIntervalReference);
        }
    },50);


}

Configuration(function(ContextRegister) {
    ContextRegister.register("ruiFABController", ruiFABController);
});
