var LoginController = function(LoginService, ScreenService, templateManager, Environment, ServerService, GeneralMethods, DashboardService, restEngine, localStorageEngine) {

    var editarPerfil = function() {
        // ScreenService.openWindow('AlterarPerfil');
    };

    this.containerAfterinit = function(container) {

        var currentUser = LoginService.getCurrentUser();
        var widgetLogin = container.getWidget('WidgetLogin');

        onEnterLogin(widgetLogin);

        if (container.restoreSession && currentUser) {

            ScreenService.openWindow(container.openWindow);
            ScreenService.buildUserData(getLocalVar('__NMOPERADOR'), [getLocalVar('__CDFILIAL') + ' - ' + getLocalVar('__NMFILIAL')], editarPerfil);

        }

    };

    function onEnterLogin(widgetLogin) {
        var fieldDemonstracao = widgetLogin.getField('demonstracao');
        var fieldEmail = widgetLogin.getField('email');

        templateManager.historyItems = ['Login'];
        widgetLogin.newRow();
        Environment.remove('/connection').then(function() {

            var ip = Environment.getLocalVar('ip');
            var lang = Environment.getLocalVar('language');
            var ultimoOperador = Environment.getLocalVar('UltimoOperador');

            if (ip) {
                fieldDemonstracao.isVisible = false;
                templateManager.updateURL(ip);
            }

            if (lang) {
                LoginService.setLanguage(lang);
            }

            if (ultimoOperador) {
                fieldEmail.setValue(ultimoOperador);
            }

            if (window && window.location) {
                var ipSemPorta = window.location.hostname + window.location.pathname;
                var porta = window.location.port;
                var index = typeof ipSemPorta === 'string' ? ipSemPorta.lastIndexOf('/mobile') : ipSemPorta;
                if (typeof ipSemPorta === 'string' && index > -1) {
                    ipSemPorta = ipSemPorta.substring(0, index) + '/';
                    Environment.setLocalVar('ipSemPorta', ipSemPorta);
                }
                if (typeof porta === 'string') {
                    Environment.setLocalVar('porta', porta);
                }
            }

            templateManager.updateTemplate();

        }).catch(function(error) {
            console.log(error.message);
        });
    }

    this.iniciaDemonstracao = function() {
        var lang = Environment.getLocalVar('language');
        if (Environment.getLocalVar('language')) {

            LoginService.setLanguage(lang);

        }

        //templateManager.updateURL("http://apresentacao.teknisa.com/tecfood/portugues/schoolmeals/backend/service/index.php");
        templateManager.updateURL("https://apresentacao-tecdiet.teknisa.com/");

        LoginService.auth('tek@teknisa.com', '1').then(function() {

            Environment.setLocalVar('UltimoOperador', '');
            Environment.setLocalVar('DEMO', true);

        }, function() {

            ScreenService.showMessage(ScreenService.i18n('Verifique sua conexão'), 'error');

        });

    };

    this.onEnterHome = function(container) {
        templateManager.historyItems = ['Dashboard'];
        DashboardService.buildUnitItem(container);
        DashboardService.buildLogItem(container);
        if (!getLocalVar("__CDFILIAL") && getLocalVar('importacaoRealizada')) {
            ScreenService.openWindow('TrocarUnidade');
        }
    };

    this.serverIsConfigured = function(widgetLogin) {

        if (Environment.getLocalVar('ip') || Environment.getLocalVar('ipSemPorta')) {

            ServerService.verifieVersionStatus().then(function(serverStatus) {

                if (serverStatus === "OK") {

                    this.login(widgetLogin);

                } else {

                    var objMessage = ServerService.getObjectMessage(serverStatus);

                    ScreenService.showMessage(ScreenService.i18n(objMessage.message), objMessage.type);

                }

            }.bind(this));

        } else {

            ScreenService.showMessage(ScreenService.i18n('Configure o ip do servidor'), 'alert');
        }

    };

    this.login = function(widget) {

        if (widget.isValid()) {

            LoginService.auth(widget.currentRow.email, widget.currentRow.password).then(function(session) {
                afterLogin(session).then(function() {
                    Environment.remove('/GruposProduto').then(function() {});
                    restEngine.post('/Patients/patientSequentialAjusta', {
                        "requestType": "Row",
                        "row": {
                            'unit': localStorageEngine.getLocalVar('__CDFILIAL')
                        }
                    }).then(function(callback) {
                        if (callback && callback.dataset && callback.dataset.patientSequentialAjusta) {
                            if (callback.dataset.patientSequentialAjusta.IDCTRLCDPACI) {
                                localStorageEngine.setLocalVar('__ISSEQUENTIAL', callback.dataset.patientSequentialAjusta.IDCTRLCDPACI);
                            }
                            if (callback.dataset.patientSequentialAjusta.IDAJUSTAPACI) {
                                localStorageEngine.setLocalVar('__ISAJUSTA', callback.dataset.patientSequentialAjusta.IDAJUSTAPACI);
                            } else {
                                localStorageEngine.setLocalVar('__ISSEQUENTIAL', null);
                                localStorageEngine.setLocalVar('__ISAJUSTA', null);
                            }
                        }
                    });
                });

            }.bind(this), function(callback) {

                if (callback.data) {

                    ScreenService.showMessage(ScreenService.i18n(callback.data.error), 'error');

                } else {

                    ScreenService.showMessage(ScreenService.i18n("Conexão perdida! Tente novamente."), 'error');
                }

            });

        }

    };

    // função que recebe dados do login após o mesmo ser efetuado com sucesso
    function afterLogin(login) {
        Environment.setLocalVar('__NMOPERADOR', login.User.NMOPERADOR);
        Environment.setLocalVar('__NRORGTRAB', login.User.NRORG);
        Environment.setLocalVar('__CDFILIAL', login.User.CDFILIAL);
        Environment.setLocalVar('__NMFILIAL', login.User.NMFILIAL);

        ScreenService.buildUserData(getLocalVar('__NMOPERADOR'), [getLocalVar('__CDFILIAL') + ' - ' + getLocalVar('__NMFILIAL')], editarPerfil);

        return GeneralMethods.verificaNovoUsuario(login.User.CDOPERADOR, login.User.DSEMAILOPER, editarPerfil).then(function() {
            return login;
        });
    }

    this.logout = function() {

        ScreenService.confirmMessage("Deseja realmente sair do sistema?", 'question', function() {
            var ipData = backUpBackendData();

            LoginService.logout().then(onLogoutSuccess, onLogoutError);

            applayBackupIP(ipData);
        });

    };

    function onLogoutError() {}

    function onLogoutSuccess() {
        LoginService.removeUserData();
        ScreenService.toggleSideMenu();
        ScreenService.openWindow("login");
    }

    function backUpBackendData() {
        var ipdata = {
            'saveConnectedIPSemPorta': getLocalVar("ipSemPorta"),
            'saveConnectedPorta': getLocalVar("porta"),
            'saveConnectedDiretorioIP': getLocalVar("diretorio"),
            'saveConnectedIP': getLocalVar("ip")
        };
        return ipdata;
    }

    function applayBackupIP(ipData) {
        setTimeout(function() {
            setLocalVar("ipSemPorta", ipData.saveConnectedIPSemPorta);
            setLocalVar("porta", ipData.saveConnectedPorta);
            setLocalVar("diretorio", ipData.saveConnectedDiretorioIP);
            setLocalVar("ip", ipData.saveConnectedIP);
        }, 300);
    }

    this.changeLanguage = function(lang) {
        Environment.setLocalVar('language', lang);
        ScreenService.setLanguage(lang);
        LoginService.setLanguage(lang);
        ScreenService.successNotification(ScreenService.i18n('Idioma alterado'));
        ScreenService.closePopup();
    };

};
Configuration(function(ContextRegister) {
    ContextRegister.register('LoginController', LoginController);
});
