var PatientController = function(templateManager, localStorageEngine, Environment, ScreenService) {

    var containerMain;
    var widgetMain;
    var widgetProfile;
    var widgetPrescription;
    var widgetAppointment;
    var widgetControlFeeding;
    var widgetNavigationStripe;

    this.cancel = function(widget) {
        ScreenService.closeSwipe();
        widget.container.getWidget('WidgetControlFeeding').activate();
    };

    // WIDGET NAVIGATION STRIPE

    this.widgetAfterMoveRow = function(widget, name) {
        if (name === "next") {
            widget.moveToNext();
        } else {
            widget.moveToPrev();
        }
        var patient = widget.currentRow;
        Environment.setCurrentPatient(patient);
        Environment.setCurrentPatientId(patient.id);

        widgetProfile.reload().then(function() {
            widgetProfile.moveToFirst();
        });

        widgetPrescription.reload().then(function() {
            if (widgetPrescription.dataSource.data.length === 0) {
                widgetPrescription.fields.forEach(function(field) {
                    field.value("");
                });
            }
            widgetPrescription.moveToFirst();
        });

        widgetAppointment.reload();
        widgetControlFeeding.reload();

    };

    this.widgetOnEnter = function(widget) {

        widget.reload().then(function() {
            widget.moveToFirst();
        });

    };

    var _initNavigationStripe = function() {

        widgetNavigationStripe.currentRow = Environment.getCurrentPatient();
        widgetNavigationStripe.dataSource.data = Environment.getDataSourceMain();

    };

    var _initContainer = function(container) {

        containerMain = container;
        widgetNavigationStripe = container.getWidget('WidgetNavigationStripe');
        widgetMain = container.getWidget('WidgetMain');
        widgetProfile = container.getWidget('WidgetProfile');
        widgetPrescription = container.getWidget('WidgetPrescription');
        widgetAppointment = container.getWidget('WidgetAppointment');
        widgetControlFeeding = container.getWidget('WidgetControlFeeding');

    };

    this.containerAfterinit = function(container) {

        _initContainer(container);
        _initNavigationStripe();
        container.restoreDefaultMode();

    };

};
Configuration(function(ContextRegister) {
    ContextRegister.register('PatientController', PatientController);
});
